/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.fabric3.jpa.spi.classloading;

import java.net.URI;

/**
 * Implements a strategy for creating or returning a classloader to set for entity manager factory instantiation for a given application classloader.
 *
 * @version $Revision$ $Date$
 */
public interface EmfClassLoaderService {

    /**
     * Returns or creates a classloader an entity manager factory can be instantiated in for an application
     *
     * @param classLoaderUri uri of the application classloader that will use the EMF
     * @return the classloader
     */
    ClassLoader getEmfClassLoader(URI classLoaderUri);
}
